]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
* %install_kernel_modules:
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # Requires:             awk
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i in I) {  A=0;                    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
116  %{?__cc:CC="%{__cc}" ; export CC ; } \
117  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
118  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
119         --host=%{_target_platform} \
120         --prefix=%{_prefix} \
121         --exec-prefix=%{_exec_prefix} \
122         --bindir=%{_bindir} \
123         --sbindir=%{_sbindir} \
124         --sysconfdir=%{_sysconfdir} \
125         --datadir=%{_datadir} \
126         --includedir=%{_includedir} \
127         --libdir=%{_libdir} \
128         --libexecdir=%{_libexecdir} \
129         --localstatedir=%{_localstatedir} \
130         --sharedstatedir=%{_sharedstatedir} \
131         --mandir=%{_mandir} \
132         --infodir=%{_infodir} \
133         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
134         %{dependencytracking} \
135 }
136
137 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
138 %__cmake        /usr/bin/cmake
139 %cmake { \
140 CC="%{__cc}" \
141 CXX="%{__cxx}" \
142 CFLAGS="%{rpmcflags}" \
143 CXXFLAGS="%{rpmcxxflags}" \
144 %{__cmake} \
145 }
146
147 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
148 %__scons        /usr/bin/scons
149 %scons { \
150 %{__scons} \
151 }
152
153 # waf. see waf.spec
154 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
155 %__waf  /usr/bin/waf
156 %waf { \
157 CC="%{__cc}" \
158 CXX="%{__cxx}" \
159 CPP="%{__cpp}" \
160 CFLAGS="%{rpmcflags}" \
161 CXXFLAGS="%{rpmcxxflags}" \
162 %{__waf} \
163 }
164
165 #----------------------------------------------------------------
166 %global configure_cache 0
167 %configure_cache_file   %{buildroot}.configure.cache
168
169 %configure {./configure \
170         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
171         CFLAGS="${CFLAGS:-%rpmcflags}" \
172         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
173         FFLAGS="${FFLAGS:-%rpmcflags}" \
174         CPPFLAGS="${CPPFLAGS:-}" \
175         %{?__cc:CC="%{__cc}"} \
176         %{?__cxx:CXX="%{__cxx}"} \
177         --host=%{_target_platform} \
178         --build=%{_target_platform} \
179         --prefix=%{_prefix} \
180         --exec-prefix=%{_exec_prefix} \
181         --bindir=%{_bindir} \
182         --sbindir=%{_sbindir} \
183         --sysconfdir=%{_sysconfdir} \
184         --datadir=%{_datadir} \
185         --includedir=%{_includedir} \
186         --libdir=%{_libdir} \
187         --libexecdir=%{_libexecdir} \
188         --localstatedir=%{_localstatedir} \
189         --sharedstatedir=%{_sharedstatedir} \
190         --mandir=%{_mandir} \
191         --infodir=%{_infodir} \
192         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
193         %{dependencytracking} \
194         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
195 }
196
197 # ------------------------------------------------------------------------
198 # Overloading of some basic macros
199 %prep \
200 %%prep\
201 export LC_ALL=C\
202 export LANG=C\
203 unset LINGUAS ||:\
204 unset LANGUAGE ||:\
205 unset LC_MESSAGES ||:\
206 unset DISPLAY ||:\
207 %{nil}
208
209 %build %%build\
210 export LC_ALL=C\
211 export LANG=C\
212 export LD_SYMBOLIC_FUNCTIONS=1\
213 unset LINGUAS ||:\
214 unset LANGUAGE ||:\
215 unset LC_MESSAGES ||:\
216 unset DISPLAY ||:\
217 %{nil}
218
219 %install \
220 %if 0%{?_enable_debug_packages}\
221 %{?buildsubdir:%{debug_package}}\
222 %endif\
223 %%install\
224 export LC_ALL=C\
225 export LANG=C\
226 export LD_SYMBOLIC_FUNCTIONS=1\
227 unset LINGUAS ||:\
228 unset LANGUAGE ||:\
229 unset LC_MESSAGES ||:\
230 unset DISPLAY ||:\
231 %{nil}
232
233 # Location of autoconf macros
234 %_aclocaldir    %(aclocal --print-ac-dir)
235
236 # Location of omf files
237 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
238
239 # Location of pkgconfig files
240 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
241
242 # Location of desktop files
243 %_desktopdir    /usr/share/applications
244 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
245
246 # Location of pixmaps for applnk/desktop files
247 %_pixmapsdir    /usr/share/pixmaps
248
249 # Location of themable icons for applnk/desktop files
250 %_iconsdir      /usr/share/icons
251
252 # Location of fonts directories
253 %_fontsdir      /usr/share/fonts
254
255 # Location of Gtk and associated libraries documentation
256 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
257
258 # Location of KDE documentation
259 %_kdedocdir     %{_defaultdocdir}/kde/HTML
260
261 # unsermake script
262 %__unsermake /usr/share/unsermake/unsermake
263
264 # Current date
265 %date           %(LC_ALL="C" date +"%a %b %d %Y")
266
267 # tmp directory
268 %tmpdir         %(echo "${TMPDIR:-/tmp}")
269
270 # Example files, programs, scripts...
271 %_examplesdir   /usr/src/examples
272
273 # Alternative kernel type/version
274 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
275
276 # The directory holding Linux kernel sources
277 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
278
279 # If non-empty "debug" macro defined, add "dbg" suffix to release number
280 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
281
282 # Requires name = version-release
283 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
284
285 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
286 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
287 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
288 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
289
290 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
291 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
292
293 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
294
295 # kernel version-release handling
296 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
297 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
298 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
299 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
300 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
301
302 # sgml macros
303 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
304 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
305 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
306 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
307 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
308 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
309 %docbook_sgmlcat_fix() { for l in \
310 '' \
311 '  -- default decl --' \
312 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
313 '  -- hacks for opensp --' \
314 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
315 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
316 '' \
317 ; do echo $l; done >> %1 \
318 }
319
320 # minimum file size needed for compressed documents.
321 # just smaller files than this get larger when compressed.
322 # some stats:
323 # - 0 byte file compressed was 25 bytes .gz
324 # - 39 byte file was compressed as 57
325 # - with test/test.spec@man 158 byte file was compressed also 158
326 %_min_compress_bytes    159
327
328 #-----------------------------------------------------------------
329 # find and gzip all files in %{_mandir} and %{infodir}
330 #
331 # Requires: xargs, find
332 #
333 #%no_install_post_compress_docs 1
334 %__spec_install_post_compress_docs { \
335 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
336         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
337                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
338                         echo "Compress $(basename $i) pages: $i"; \
339                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
340                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
341                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
342                 fi; \
343         done; \
344 }; __spec_install_post_compress_docs } }
345
346 #-----------------------------------------------------------------
347 # Strip executable binaries and shared object files
348 #
349 # Requires: find, awk, strip, cut, xargs
350 #
351 #%no_install_post_strip 1
352 %__spec_install_post_strip {%{!?debug: \
353 %{!?no_install_post_strip:__spec_install_post_strip() { \
354 if [ -d "$RPM_BUILD_ROOT" ]; then \
355         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
356         if [ -z "$filelist" ]; then \
357                 return; \
358         fi; \
359         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
360         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
361         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
362         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
363         if [ -n "$elfexelist" ]; then \
364                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
365                 chmod u+w $elfexelist; \
366                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
367                 echo "DONE"; \
368         fi; \
369         if [ -n "$elfsharedlist" ]; then \
370                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
371                 chmod u+w $elfsharedlist; \
372                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
373                 echo "DONE"; \
374         fi; \
375         if [ -n "$archiveslist" ]; then \
376                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
377                 chmod u+w $archiveslist; \
378                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
379                 echo "DONE"; \
380         fi; \
381 fi; }; __spec_install_post_strip } } }
382
383 #-----------------------------------------------------------------
384 # remove all RPATH from executable binaries and shared object files
385 #
386 # Requires: find, awk, cut, xargs, chrpath, uname
387 #
388 #%no_install_post_chrpath       1
389 %__spec_install_post_chrpath {%{!?debug: \
390 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
391 if [ -d "$RPM_BUILD_ROOT" ]; then \
392         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
393         if [ -n "$files" ]; then \
394                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
395         fi
396         #"
397         if [ -n "$objs" ]; then \
398                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
399                 echo "$objs" | \
400                 while read file; do \
401                         rpath= ; \
402                         chmod u+w "$file"; \
403                         for dir in `chrpath -l "$file" | \
404                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
405                                         case $dir in \
406                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
407                                                 echo "remove-rpath: $dir in $file"; \
408                                                 ;; \
409                                         * ) \
410                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
411                                                 else rpath="$rpath:$dir" ; fi ; \
412                                                 ;; \
413                                         esac ; \
414                         done ; \
415                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
416                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
417                 done; \
418         fi; \
419 fi; }; __spec_install_post_chrpath } } }
420
421 #-----------------------------------------------------------------
422 # Find and gzip all kernel modules
423 #
424 # Requires: find
425 #
426 #%no_install_post_compress_modules      1
427 %__spec_install_post_compress_modules { \
428 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
429         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
430                 echo "Compress kernel modules"; \
431                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
432                 echo "$q" | xargs -r %{__gzip} -9nf; \
433                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
434                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
435                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
436         fi; \
437 }; __spec_install_post_compress_modules } }
438
439 # Remove common Perl files we don't package
440 %__spec_install_post_perl_clean {\
441 %{!?no_install_post_perl_clean: \
442 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
443 } }
444
445 #-----------------------------------------------------------------
446 # Update GConf2 schemas
447 #
448 # Requires: GConf2
449 #
450 %gconf_schema_install() \
451         umask 022; \
452         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
453         %{nil}
454
455 %gconf_schema_uninstall() \
456 if [ $1 = 0 ]; then \
457         umask 022; \
458         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
459 fi \
460 %{nil}
461
462 #-----------------------------------------------------------------
463 # Update desktop MIME database
464 # requires: desktop-file-utils
465 #
466 %update_desktop_database_post() {{ \
467         umask 022; \
468         /usr/bin/update-desktop-database -q; \
469 }}
470
471 %update_desktop_database_postun() {{ \
472 if [ $1 = 0 ]; then \
473         umask 022; \
474         /usr/bin/update-desktop-database -q; \
475 fi \
476 }}
477
478 #-----------------------------------------------------------------
479 # Update shared MIME info database
480 # requires: shared-mime-info
481 #
482 %update_mime_database() {{ \
483         umask 022; \
484         /usr/bin/update-mime-database %{_datadir}/mime; \
485 }}
486
487 #-----------------------------------------------------------------
488 # Update icon cache
489 # requires: gtk+
490 #
491 %update_icon_cache() {{ \
492         umask 022; \
493         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
494 }}
495
496 #-----------------------------------------------------------------
497 # Update scrollkeeper database
498 # requires: scrollkeeper
499 #
500 %scrollkeeper_update_post() \
501         /usr/bin/scrollkeeper-update -q; \
502         %{nil}
503
504 %scrollkeeper_update_postun() \
505 if [ $1 = 0 ]; then \
506         /usr/bin/scrollkeeper-update -q; \
507 fi \
508 %{nil}
509
510 #-----------------------------------------------------------------
511 # post %install sequence:
512 # - autodeps exceptions
513 # - compress all man and info pages,
514 # - strip all ELF executables and ELF shared objects if not %debug.
515 # - compress kernel modules if any
516
517 ###################################################################
518 # Requires/Provides automation
519 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
520 #
521 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
522 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
523 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
524 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
525 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
526 #%_noautocompressdoc    %{nil}
527 #
528 %_missing_doc_files_terminate_build     1%{nil}
529 %_unpackaged_files_terminate_build      %{nil}
530 # (X)emacs support
531 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
532 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
533 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
534
535 %__php_provides %{nil}
536 %__php_requires %{nil}
537 %__perl_provides %{nil}
538 %__perl_requires %{nil}
539 %__mono_provides %{nil}
540 %__mono_requires %{nil}
541
542 # Perl specific macro definitions.
543 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
544 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
545 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
546 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
547 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
548 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
549
550 # Ruby
551 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
552 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
553 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
554 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
555 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
556 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
557 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
558 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
559
560 %php_pear_dir           /usr/share/pear
561 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
562 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
563
564 # directory where php includes are installed on system.
565 %__php_includedir               /usr/include/php
566 # extract php/zend api versions
567 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
568 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
569 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
570 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
571 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
572 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
573 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
574
575 # helper macro
576 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
577
578 # macros for public use
579 # for php extensions (php-pecl)
580 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
581 %{__php_api_requires zend_module_api} \
582 %{__php_api_requires -v %php_major_version debug php_debug} \
583 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
584
585 # for zend extensions
586 %requires_zend_extension %{__php_api_requires zend_module_api} \
587 %{__php_api_requires zend_extension_api} \
588 %{__php_api_requires -v %php_major_version debug php_debug} \
589 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
590
591 # for php pdo modules (php-pecl-PDO_*)
592 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
593
594 # for using PHP post scripts. for PHP >= 5.0
595 %php_webserver_restart \
596 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
597 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
598 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
599         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
600         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
601                 %service -q php-fcgi restart \
602         fi \
603 fi \
604 %{nil}
605
606 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
607 %php4_webserver_restart \
608 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
609 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
610 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
611         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
612         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
613                 %service -q php-fcgi restart \
614         fi \
615 fi \
616 %{nil}
617
618 # Python specific macro definitions.
619 # python main version
620 %py_ver                 %(python -c "import sys; print sys.version[:3]")
621
622 # directories
623 %py_prefix              %(python -c "import sys; print sys.prefix")
624 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
625 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
626 %py_incdir              /usr/include/python%{py_ver}
627 %py_sitedir             %{py_libdir}/site-packages
628 %py_sitescriptdir %{py_scriptdir}/site-packages
629 %py_dyndir              %{py_libdir}/lib-dynload
630
631 # pure python modules compilation
632 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
633
634 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
635
636 # Software written in Python language require Python with main version
637 %pyrequires_eq() Requires:      %1
638
639 # Hardlink binary identical .pyc and .pyo files
640 # (idea by glen <at> pld-linux <dot> org)
641 %__spec_install_post_py_hardlink {\
642 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
643 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
644         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
645         if cmp -s "$a" "$b"; then \
646                 ln -f "$a" "$b"; \
647         fi; \
648 done \
649 }; __spec_install_post_py_hardlink } }
650
651 # remove python sources, so that check-files won't complain
652 # (idea by glen <at> pld-linux <dot> org)
653 %py_postclean() \
654 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
655  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
656 done \
657 %{nil}
658
659 # depmod macro
660 %depmod() { \
661 umask 022; \
662 if [ -e /boot/System.map-%1 ]; then \
663         /sbin/depmod -a -F /boot/System.map-%1 %1; \
664 else \
665         if [ -e /boot/System.map ]; then \
666                 /sbin/depmod -a -F /boot/System.map %1; \
667         else \
668                 /sbin/depmod -a %1; \
669         fi \
670 fi; \
671 }
672
673 # XMMS specific macros
674 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
675 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
676 %xmms_version                   %(xmms-config --version 2>/dev/null)
677 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
678 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
679 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
680 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
681 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
682 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
683 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
684
685 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
686
687 # user/group checking macros
688 #
689 # Usage:
690 #       %userremove myuser
691 #
692 %userremove     /usr/lib/rpm/user_group.sh user del
693 %groupremove    /usr/lib/rpm/user_group.sh group del
694 #
695 # Usage:
696 #       if %usertestrm myuser; then
697 #               /usr/sbin/userdel -r myuser
698 # Note:
699 #       use these macros only if you need to call userdel/groupdel with
700 #       a non-standard option or take an extra action; otherwise use the
701 #       %userremove/%groupremove macros
702 #
703 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
704 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
705 # user group membership management macros
706 #
707 # Usage:
708 #       %addusertogroup myuser agroup
709 #
710 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
711
712 # banner support (useful in {pre,post}{,un} and triggers)
713 #
714 # Usage:
715 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
716 # the banner text, the banner text
717 # the banner text, and following line
718 #EOF
719 # You can use any form of here-document, <<'EOF' <<-EOT will do.
720 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
721 #
722 # -a   - append to the banner
723 # -e   - send to stderr instead of stdout
724 # -n   - no show banner (overrides -t)
725 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
726 %banner(aent:)  \
727 RPM_SCRIPTVERBOSITY=5 \
728 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
729 if [ -x /usr/bin/banner.sh ]; then \
730         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
731 else \
732         CMD="cat%{-e: >&2}" \
733 fi \
734 eval $CMD %2%{?3: %3} \
735 %nil
736
737 # useradd/groupadd macros
738 # Author: Elan Ruusamäe <glen@pld-linux.org>
739 #
740 # Usage:
741 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
742 #   [-g initial_group] [-G group[,...]] login
743 #
744 #  -u uid. REQUIRED
745 #  -g gid/group. REQUIRED
746 #  -s defaults to /bin/false
747 #  -d defaults to /usr/share/empty
748 #  -c No default
749 #  -r is accepted but ignored (it's always set)
750 #  -k skeleton dir. defaults to /usr/share/empty
751 # rpm specific flags
752 #  -P package name. defaults to %{name}
753 #
754 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
755 %{!-u:%{error:useradd: Required argument -u missing}} \
756 %{!-g:%{error:useradd: Required argument -g missing}} \
757 %{!?1:%{error:useradd: Required parameter login missing}} \
758 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
759         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
760                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
761                 exit 1 \
762         fi \
763 else \
764         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
765         /usr/sbin/useradd \\\
766                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
767                 -u %{-u*} \\\
768                 -r \\\
769                 -d %{-d*}%{!-d:/usr/share/empty} \\\
770                 -s %{-s*}%{!-s:/bin/false} \\\
771                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
772                 -g %{-g*} \\\
773                 %{-M} \\\
774                 %{-G:-G %{-G*}} \\\
775                 %{expand:%{%{#}}} 1>&2 || exit $? \
776         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
777 fi;
778
779 # Usage:
780 #   %groupadd [-P package] [-g gid] group
781 #
782 # -g gid. REQUIRED
783 #
784 # Sample:
785 #   %groupadd -P %{name}-base -g %{gid} %{name}
786
787 %groupadd(g:P:rfo)      \
788 %{!-g:%{error:groupadd: Required argument -g missing}} \
789 %{!?1:%{error:groupadd: Required parameter group missing}} \
790 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
791         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
792                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
793                 exit 1 \
794         fi \
795 else \
796         echo "Adding group %{1} GID=%{-g*}." \
797         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
798         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
799 fi;
800
801 # apache_config_{install/uninstall} macros *DEPRECATED*
802 # Author: Elan Ruusamäe <glen@pld-linux.org>
803 #
804 # You should use webapp macros instead. these are here until single piece of
805 # them is gone from specs ;)
806 #
807 # The config is installed/removed inside trigger, this means that you can any
808 # time install apache1 or apache package and the configuration file is updated.
809 # if you don't need the config for various reason for specific apache, just
810 # remove the symlink from apache config directory. the trigger will not put the
811 # config again to that version of apache. In other words the config is linked
812 # to apache config directory on first install of PACKAGE or apache.
813 #
814 # should be called in trigger body:
815 #  %triggerin -- apache1 >= 1.3.33-2
816 #  %apache_config_install -v 1
817 #
818 # Add package's apache config to apache config.
819 #
820 # Usage:
821 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
822 #
823 #  -v REQUIRED: specify apache version. can be 1 or 2.
824 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
825 #  -n OPTIONAL: specify config "slot". defaults to 99
826 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
827 #
828 # Internal macros. don't use ;).
829 # expands apache config dir by apache version at build time.
830 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
831 # expands apache service name by apache version at build time.
832 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
833
834 %apache_config_install(fv:c:n:) \
835 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
836 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
837 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
838         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
839 fi\
840 # reload apache if the config symlink is there\
841 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
842         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
843         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
844                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
845         fi\
846 fi\
847 %{nil}
848
849 # Remove package's apache config from apache config.
850 #
851 # Usage:
852 #   %apache_config_uninstall -v {1|2} -n 99
853 #
854 #  -v REQUIRED: specify apache version. can be 1 or 2.
855 #  -n OPTIONAL: specify config "slot". defaults to 99
856 %apache_config_uninstall(v:n:) \
857 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
858 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
859 # remove link if either of the packages are gone \
860 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
861         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
862                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
863                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
864                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
865                 fi \
866         fi \
867 fi \
868 %{nil}
869
870 # webapp macros
871 # Author: Elan Ruusamäe <glen@pld-linux.org>
872 #
873 # The config is installed/removed inside trigger, this means that you can any
874 # time install apache1/apache/lighttpd package and the configuration file is
875 # updated. if you don't need the config for various reason for specific
876 # webserver, just remove the symlink from config directory using webapp
877 # program. the trigger will not recreate the symlink on upgrades. In other
878 # words the config is linked to webserver config directory on first install of
879 # PACKAGE or WEBSERVER.
880 #
881 # Add package's webserver config to webserver webapps dir.
882 # Usage:
883 #   %webapp_register WEBSERVER WEBAPP
884 #
885 %webapp_register() \
886 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
887 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
888         /usr/sbin/webapp register %1 %2\
889 fi\
890 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
891 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
892         %{expand:%service -q %%1 reload}\
893 fi\
894 %{nil}
895
896 # Remove package's config from webserver webapps dir.
897 # Usage:
898 #   %webapp_register [-f] WEBSERVER WEBAPP
899 %webapp_unregister(f) \
900 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
901 # remove link if either of the packages are gone \
902 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
903         /usr/sbin/webapp unregister %1 %2\
904         %{expand:%service -q %%1 reload}\
905 fi \
906 %{nil}
907
908 # see browser-plugins.spec / template-browser-plugin.spec
909 # Author: Elan Ruusamäe <glen@pld-linux.org>
910 %nsplugin_install(d:f) { \
911 # create link if it's first install of either of the packages \
912 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
913 ( \
914 %( \
915         for file in %{*}; do \
916                 echo echo Installing $file to %{-d*}; \
917                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
918         done ) \
919 ) | ( %banner -t 5 -e %{name}-in ); fi; \
920 }
921
922 %nsplugin_uninstall(d:) { \
923 # remove link if either of the packages are gone \
924 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
925 ( \
926 %( \
927         for file in %{*}; do \
928                 echo echo Removing $file from %{-d*}; \
929                 echo "rm -f %{-d*}/$file;"; \
930         done ) \
931 ) | ( %banner -t 5 -e %{name}-un ); fi; \
932 }
933
934 # service macro.
935 # Author: Elan Ruusamäe <glen@pld-linux.org>
936 #
937 # calls usual service restart on package %post, but skips the restart if
938 # administrator has disabled automatic service restarts in either global
939 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
940 #
941 # Usage:
942 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
943 #
944 #  -q be silent when service isn't started (for scriplets restaring other package's services)
945 #
946 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
947
948
949 # Java macros. based on jpackage macros.java
950 #
951 # Root directory where all Java VMs/SDK/JREs are installed.
952 %_jvmdir                %{_libdir}/jvm
953
954 # Root directory where all Java VMs/SDK/JREs expose their jars
955 %_jvmjardir             %{_libdir}/jvm-exports
956
957 # Root directory for all Java VM/SDK/JRE's private things.
958 %_jvmprivdir    %{_libdir}/jvm-private
959
960 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
961 %_jvmlibdir             %{_libdir}/jvm
962
963 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
964 %_jvmdatadir    %{_datadir}/jvm
965
966 # Root directory for all configurations parts of Java VM/SDK/JRE's
967 %_jvmsysconfdir %{_sysconfdir}/jvm
968
969 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
970 %_jvmcommonlibdir       %{_libdir}/jvm-common
971
972 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
973 %_jvmcommondatadir      %{_datadir}/jvm-common
974
975 # Root directory for all common configurations parts of Java VM/SDK/JRE's
976 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
977
978 # Directory where arch-specific (JNI) version-independent jars are installed.
979 %_jnidir                %{_libdir}/java
980
981
982 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
983
984 %ant                    JAVA_HOME=%{java_home} ant
985 %jar                    %{java_home}/bin/jar
986 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
987 %javac                  %{java_home}/bin/javac
988 %javadoc                %{java_home}/bin/javadoc
989
990 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
991
992 %jpackage_script() \
993 install -d $RPM_BUILD_ROOT%{_bindir}\
994 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
995 #!/bin/sh\
996 #\
997 # %{name} script\
998 # JPackage Project <http://www.jpackage.org/>\
999 \
1000 # Source functions library\
1001 . %{_javadir}-utils/java-functions\
1002 \
1003 # Source system prefs\
1004 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1005     . %{_sysconfdir}/java/%{name}.conf\
1006 fi\
1007 \
1008 # Source user prefs\
1009 if [ -f $HOME/.%{name}rc ]; then\
1010     . $HOME/.%{name}rc\
1011 fi\
1012 \
1013 # Configuration\
1014 MAIN_CLASS=%1\
1015 BASE_FLAGS=%2\
1016 BASE_OPTIONS=%3\
1017 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1018 \
1019 # Set parameters\
1020 set_jvm\
1021 set_classpath $BASE_JARS\
1022 set_flags $BASE_FLAGS\
1023 set_options $BASE_OPTIONS\
1024 \
1025 # Let's start\
1026 run "$@"\
1027 EOF
1028
1029 # PEAR install macros
1030 # Author: Elan Ruusamäe <glen@pld-linux.org>
1031 #
1032 # Usage:
1033 #       %%pear_package_setup [-a #] [-n FMT]
1034 #
1035 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1036 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1037 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1038 #
1039 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1040 # destination hierarchy. you should copy the tree to buildroot after
1041 # patching/reorganizing with %%pear_package_install.
1042 #
1043 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1044 # line endings.
1045 #
1046 # the pear install process output is recorded to install.log, you should put it
1047 # to %%doc for later debug or just for information.
1048 #
1049 # additionally additional-packages.txt is produced if it was detected that the
1050 # package has optional dependencies. the file format is suitable of displaying
1051 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1052 # automatically added for this file.
1053
1054
1055 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1056 %__pear_install_log \
1057 tee install.log \
1058 # make post message of optional packages \
1059 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1060 if [ -s optional-packages.txt ]; then \
1061         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1062 else \
1063         rm -f optional-packages.txt \
1064 fi \
1065 %{nil}
1066
1067 # command invoking pear cli
1068 %__pear /usr/bin/pear
1069
1070 # the main macro.
1071 # using this macro will append optional-packages.txt to the nocompressdoc list
1072 # as it's displayed to user after package install. and adding additional gzip
1073 # dep is just waste ;)
1074 %pear_package_setup(a:n:z) \
1075 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1076 %define builddir %{_builddir}/%{srcdir} \
1077 %setup -q -c -T -n %{srcdir} \
1078 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1079 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1080 %__pear \\\
1081         -c pearrc \\\
1082         -d doc_dir=/docs \\\
1083         -d php_dir=%{php_pear_dir} \\\
1084         -d bin_dir=%{_bindir} \\\
1085         -d data_dir=%{php_pear_dir}/data \\\
1086         -d test_dir=%{php_pear_dir}/tests \\\
1087         install \\\
1088         --packagingroot=%{builddir} \\\
1089         --offline \\\
1090         --nodeps \\\
1091         %{-f:--force} \\\
1092         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1093 %{-z:cd ..} \
1094 cat %{-z:$_N/}.install.log | %__pear_install_log \
1095 \
1096 # undos sources \
1097 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1098 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1099 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1100 %{nil}
1101
1102 # copies exctracted PEAR package structure to buildroot.
1103 # also copies PEAR registry file.
1104 # please use this macro, for future extensions being possible.
1105 %pear_package_install() \
1106 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1107 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1108 # help the developer out a little: \
1109 if [ -f _noautoreq ]; then \
1110         echo "AutoReqdep detected:" \
1111         echo "_noautoreq $(cat _noautoreq)" \
1112 fi \
1113 %{nil}
1114
1115
1116 # Register OpenLDAP schema.
1117 # Author: Elan Ruusamäe <glen@pld-linux.org>
1118 #
1119 # Usage:
1120 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1121 #
1122 #  -d specify dependant schemas, separated by comma
1123 #
1124 %openldap_schema_register(d:) \
1125 for schema in %*; do \
1126         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1127                 %{__sed} -i -e " \
1128                         /^include.*local.schema/{ \
1129                                 iinclude\\t     $schema\
1130                         } \
1131                 " /etc/openldap/slapd.conf \
1132         fi \
1133 done \
1134 # enable dependant schemas \
1135 if [ "%{-d*}" ]; then \
1136         %{__sed} -i -e ' \
1137         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1138                 s/^#// \
1139         }' /etc/openldap/slapd.conf \
1140 fi \
1141 %{nil}
1142
1143 # Unregister OpenLDAP schema.
1144 # Author: Elan Ruusamäe <glen@pld-linux.org>
1145 #
1146 # Usage:
1147 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1148 #
1149 %openldap_schema_unregister() \
1150 for schema in %*; do \
1151         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1152                 %{__sed} -i -e " \
1153                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1154                 # for symmetry it would be nice if we disable enabled schemas in post, \
1155                 # but we really can not do that, it would break something else. \
1156                 " /etc/openldap/slapd.conf \
1157         fi \
1158 done \
1159 %{nil}
1160
1161 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1162
1163
1164 # Build modules for kernels 2.6
1165 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1166 #
1167 # Usage:
1168 #       %build_kernel_modules -m <modules> -C <directory>
1169 #
1170 #  remember that proper Makefile is still required
1171 # Options:
1172 #  -m <modules> (required) -- comma-separated list of modules to save,
1173 #               without .ko extension, may be placed in subdirectory
1174 #  -C <directory> -- change to <directory> before doing anything
1175 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1176 #  -c -- do not execute make clean
1177 #  <additional arguments> -- all additional arguments will be passed to
1178 #               make modules
1179 #
1180 # Additional patching supported via here document. Try:
1181 #       %build_kernel_modules -m module <<'EOF'
1182 #       your patch script here
1183 #       EOF
1184 # Don't use it unless patching depends on config options.
1185
1186 # Developer note: don't touch it unless you know how to handle '\'.
1187 # - \ in script expands to nothing
1188 # - \\\ in script expands to \
1189 # - \\\ inside definition expands to noting
1190 # - \\\\\\\ inside definition expands to \
1191 # - in last line \ has to touch arguments so arguments passing
1192 #   in new lines (using \) will be supported
1193
1194 %build_kernel_modules(p:P:m:C:c)                                                                        \
1195 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1196                                                                                                                                         \
1197 %define Opts                                                                                                            \\\\\\\
1198 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1199         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1200         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1201         %else                                                                                                                   \\\
1202         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1203         %endif                                                                                                                  \\\
1204 %else                                                                                                                           \\\
1205         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1206 %endif                                                                                                                          \
1207 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1208                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1209                                                                                                                                         \
1210 %{?-C:cd %{-C*}}                                                                                                        \
1211 compile() {                                                                                                                     \
1212         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1213         set -e -x                                                                                                               \
1214                                                                                                                                         \
1215 for cfg in %{?with_dist_kernel:%{?with_smp:smp} %{?with_up:up}}%{!?with_dist_kernel:nondist}; do \
1216         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1217                                                                                                                                         \
1218         rm -rf o                                                                                                                \
1219         install -d o/include/linux                                                                              \
1220         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1221         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1222         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1223 %ifarch ppc ppc64                                                                                                       \
1224         install -d o/include/asm                                                                                \
1225         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -sf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm    \
1226         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1227 %else                                                                                                                           \
1228         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1229 %endif                                                                                                                          \
1230                                                                                                                                         \
1231         set +x                                                                                                                  \
1232         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1233         set -x                                                                                                                  \
1234                                                                                                                                         \
1235         %if %{with dist_kernel}                                                                                 \
1236                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1237                         %{-p*} %{-P*}                                                                                   \\\
1238                         %{MakeOpts}                                                                                             \
1239         %else                                                                                                                   \
1240                 install -d o/include/config                                                                     \
1241                 touch o/include/config/MARKER                                                           \
1242                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1243         %endif                                                                                                                  \
1244                                                                                                                                         \
1245         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1246                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1247                 M=$PWD %{MakeOpts}}                                                                                     \
1248         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1249                 ${1+"$@"}                                                                                                       \\\
1250                 M=$PWD %{MakeOpts}                                                                                      \
1251                                                                                                                                         \
1252         for MODULE in {%{-m*},}; do                                                                             \
1253                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1254         done                                                                                                                    \
1255 done                                                                                                                            \
1256 %{?-C:cd -}                                                                                                                     \
1257 }                                                                                                                                       \
1258 compile %{*}\
1259 %{nil}
1260
1261
1262 # Install kernel modules built by %build_kernel_modules
1263 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1264 #
1265 # Usage:
1266 #       %install_kernel_modules -m <modules> -d <directory>
1267 #
1268 # Options:
1269 #  -m <modules> (required) -- comma-separated list of modules to install,
1270 #               without .ko extension, may be placed in subdirectory
1271 #  -d <directory> (required) -- in what subdirectory modules should be
1272 #               installed (eg. misc, kernel/drivers/net)
1273 #  -s <suffix> -- suffix to use when installing modules, useful when module
1274 #               with same name exists in kernel already
1275 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1276 #               for definig aliases, only useful with -s
1277
1278 %install_kernel_modules(m:d:s:n:)                                                                       \
1279 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1280 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1281 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1282                                                                                                                                         \
1283 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1284 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1285                                                                                                                                         \
1286 install -d %{KernelD}{,smp}/%{-d*}                                                                      \
1287 %{?-s:install -d %{ModprobeD}{,smp}}                                                            \
1288                                                                                                                                         \
1289 for MODULE in {%{-m*},}; do                                                                                     \
1290         [ -n "${MODULE}" ] || continue                                                                  \
1291         MNAME=${MODULE##*/}                                                                                             \
1292         %if %{without dist_kernel}                                                                              \
1293                 install %{MODULE}-nondist.ko                                                            \\\
1294                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1295                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1296                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1297         %else                                                                                                                   \
1298         %if %{with up}                                                                                                  \
1299                 install ${MODULE}-up.ko                                                                         \\\
1300                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1301                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1302                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1303         %endif                                                                                                                  \
1304         %if %{with smp}                                                                                                 \
1305                 install ${MODULE}-smp.ko                                                                        \\\
1306                         %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                   \
1307                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1308                         >> %{ModprobeD}smp/%{-n*}.conf}                                                 \
1309         %endif                                                                                                                  \
1310         %endif                                                                                                                  \
1311 done                                                                                                                            \
1312 %{nil}
1313
1314 # patchset macros
1315 # Author: Elan Ruusamäe <glen@pld-linux.org>
1316 #
1317 # Usage:
1318 #   %patchset_source -f <seq(1) format> <start> [<end>]
1319 #   %patchset_patch <start> [<end>]
1320 #
1321 # If <end> is omited, it is assumed to be <start>.
1322 #
1323 # For example in preamble:
1324 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1325 # and in %prep:
1326 #  %patchset_patch 33 44
1327
1328 # generate SourceX urls from range START STOP
1329 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1330 # The sources start from 10000
1331 %patchset_source(f:b:) %(
1332         base=%{-b*}%{!-b*:10000};
1333         start=$(expr $base + %1);
1334         end=$(expr $base + %{?2}%{!?2:%{1}});
1335         # we need to call seq twice as it doesn't allow two formats
1336         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1337         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1338         paste %{tmpdir}/__ps{1,2};
1339         rm -f %{tmpdir}/__ps{1,2};
1340 ) \
1341 %{nil}
1342
1343 # apply sources from %patchset_source
1344 # -p specify -pX for %patch line
1345 # -b base offset: defaults to 10000
1346 %patchset_patch(f:p:b:) %(
1347         base=%{-b*}%{!-b*:10000};
1348         start=$(expr $base + %1);
1349         end=$(expr $base + %{?2}%{!?2:%{1}});
1350         echo ": patchset_patch %1%{?2: to %2}";
1351         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1352 ) \
1353 %{nil}
1354
1355 # browser plugins v2
1356 # Author: Elan Ruusamäe <glen@pld-linux.org>
1357 #
1358 # Usage:
1359 #       %browser_plugins_add_browser <name> -p <plugindir>
1360 #
1361 #  <name> (required) -- name of the browser. usually %{name}.
1362 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1363 #  -b -- default blacklists
1364 #  -a <arch> override arch
1365 #
1366 # Example:
1367 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1368
1369 %_browserpluginsconfdir         /etc/browser-plugins
1370 %_browserpluginsdir                     %{_libdir}/browser-plugins
1371 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1372
1373 %browser_plugins_add_browser(p:b:a:) \
1374         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1375         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1376         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1377         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1378         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1379         %{-b:cat >> $blacklist_file %{-b*}} \
1380 %{nil}
1381
1382 # vim:ts=4 sw=4 noet syn=spec
This page took 0.270275 seconds and 4 git commands to generate.